Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"")

cam = CreateCamera()
PositionEntity cam,0,10,-20

plane = CreatePlane()
EntityColor plane,64,128,128

light = CreateLight()

Global PressPapierMesh = LoadMesh("PressPapier.b3d")
HideEntity PressPapierMesh

HullMesh = LoadMesh("PressPapierPhys.b3d")
Global PressPapierHull = BodyCreateHull(HullMesh, 1)
pxBodySetFlagCollision(Int PressPapierHull, 0)
FreeEntity HullMesh

Repeat

If KeyHit(57) Then CreatepxBody(0,10,0)

pxRenderPhysic(60,0)
UpdatepxBodies()

RenderWorld()
Flip

Until KeyHit(1)
End

Type pxBody
	Field mesh
	Field body
End Type

Function UpdatepxBodies()
	For pxB.pxBody = Each pxBody
		pxBodySetEntity pxB\mesh, pxB\body
	Next
End Function

Function CreatepxBody(x#,y#,z#)	
	pxB.pxBody = New pxBody
	
	pxB\mesh = CopyEntity(PressPapierMesh)
	pxB\body = pxCopyBody(PressPapierHull)

	pxBodySetPosition pxB\body,x,y,z
End Function

Function BodyCreateHull%(mesh%, mass#)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, mass)
	FreeBank vbank
	Return bbb
End Function